searchData={"items":[{"type":"module","title":"Ueberauth.Strategy.IdAustria","doc":"Provides an Ueberauth strategy for authenticating with ID Austria (the austrian eIDAS implementation).\nSee the [eIDAS Regulation](https://digital-strategy.ec.europa.eu/en/policies/eidas-regulation) for infos about eIDAS.\n\n#","ref":"Ueberauth.Strategy.IdAustria.html"},{"type":"module","title":"Setup - Ueberauth.Strategy.IdAustria","doc":"You need to register your application with the austrian government.\n\nInformation about registering can be obtained [from the EGIZ](https://eid.egiz.gv.at/anbindung/registrierung/).\n\nInclude the provider in your configuration for Ueberauth\n\n    config :ueberauth, Ueberauth,\n      providers: [\n        eid: { Ueberauth.Strategy.IdAustria, [] }\n      ]\n\nThen include the configuration:\n\n    config :ueberauth, Ueberauth.Strategy.IdAustria.OAuth,\n      client_id: System.get_env(\"EID_CLIENT_ID\"),\n      client_secret: System.get_env(\"EID_CLIENT_SECRET\")\n\nIf you haven't already, create a pipeline and setup routes for your callback handler\n\n    pipeline :auth do\n      Ueberauth.plug \"/auth\"\n    end\n\n    scope \"/auth\" do\n      pipe_through [:browser, :auth]\n\n      get \"/:provider/callback\", AuthController, :callback\n    end\n\n\nCreate an endpoint for the callback where you will handle the `Ueberauth.Auth` struct\n\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n\n      def callback_phase(%{ assigns: %{ ueberauth_failure: fails } } = conn, _params) do\n        # do things with the failure\n      end\n\n      def callback_phase(%{ assigns: %{ ueberauth_auth: auth } } = conn, params) do\n        # do things with the auth\n      end\n    end","ref":"Ueberauth.Strategy.IdAustria.html#module-setup"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.credentials/1","doc":"Includes the credentials from the ID Austria token response.","ref":"Ueberauth.Strategy.IdAustria.html#credentials/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.default_options/0","doc":"","ref":"Ueberauth.Strategy.IdAustria.html#default_options/0"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.extra/1","doc":"Stores the raw information obtained from the ID Austria id_token.","ref":"Ueberauth.Strategy.IdAustria.html#extra/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.handle_cleanup!/1","doc":"Cleans up the private area of the connection used for passing the raw ID Austria response around during the callback.","ref":"Ueberauth.Strategy.IdAustria.html#handle_cleanup!/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.handle_request!/1","doc":"Handles the initial redirect to the ID Austria authentication page.\n\nThe request will include the state parameter that was set by ueberauth (if available)","ref":"Ueberauth.Strategy.IdAustria.html#handle_request!/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.info/1","doc":"Fetches the fields to populate the info section of the `Ueberauth.Auth` struct.","ref":"Ueberauth.Strategy.IdAustria.html#info/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.uid/1","doc":"Fetches the uid field from the id token.","ref":"Ueberauth.Strategy.IdAustria.html#uid/1"},{"type":"module","title":"Ueberauth.Strategy.IdAustria.OAuth","doc":"An implementation of OAuth2 for ID Austria.\n\nTo add your `client_id` and `client_secret` include these values in your configuration.\n\n    config :ueberauth, Ueberauth.Strategy.IdAustria.OAuth,\n      client_id: System.get_env(\"EID_CLIENT_ID\"),\n      client_secret: System.get_env(\"EID_CLIENT_SECRET\")","ref":"Ueberauth.Strategy.IdAustria.OAuth.html"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.authorize_url/2","doc":"","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#authorize_url/2"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.authorize_url!/2","doc":"Provides the authorize url for the request phase of Ueberauth. No need to call this usually.","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#authorize_url!/2"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.client/1","doc":"Construct a client for requests to ID Austria.\n\nOptionally include any OAuth2 options here to be merged with the defaults.\n\n    Ueberauth.Strategy.IdAustria.OAuth.client(redirect_uri: \"http://localhost:4000/auth/eid/callback\")\n\nThis will be setup automatically for you in `Ueberauth.Strategy.IdAustria`.\nThese options are only useful for usage outside the normal callback phase of Ueberauth.","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#client/1"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.get/4","doc":"","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#get/4"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.get_token/3","doc":"","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#get_token/3"},{"type":"function","title":"Ueberauth.Strategy.IdAustria.OAuth.get_token!/2","doc":"","ref":"Ueberauth.Strategy.IdAustria.OAuth.html#get_token!/2"},{"type":"module","title":"UeberauthIdAustria","doc":"Überauth ID-Austria Application Module\n\nThe application starts its supervisor and a configuration agent.","ref":"UeberauthIdAustria.html"},{"type":"module","title":"UeberauthIdAustria.Config","doc":"Configuration Agent","ref":"UeberauthIdAustria.Config.html"},{"type":"function","title":"UeberauthIdAustria.Config.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"UeberauthIdAustria.Config.html#child_spec/1"},{"type":"function","title":"UeberauthIdAustria.Config.oauth/0","doc":"Returns the configuration for the oauth client","ref":"UeberauthIdAustria.Config.html#oauth/0"},{"type":"function","title":"UeberauthIdAustria.Config.reload/0","doc":"Reloads the configuration","ref":"UeberauthIdAustria.Config.html#reload/0"},{"type":"function","title":"UeberauthIdAustria.Config.start_link/1","doc":"","ref":"UeberauthIdAustria.Config.html#start_link/1"},{"type":"function","title":"UeberauthIdAustria.Config.verify_key/0","doc":"Returns the JWT verify key.","ref":"UeberauthIdAustria.Config.html#verify_key/0"},{"type":"extras","title":"License","doc":"# The MIT License (MIT)\n\nCopyright (c) 2023 Hofstätter Healthcare GmbH, 578077p, St. Pölten, Austria\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Überauth IDAustria\n\nProvides an Ueberauth strategy for authenticating with ID Austria (the austrian eIDAS implementation).\nSee the [eIDAS Regulation](https://digital-strategy.ec.europa.eu/en/policies/eidas-regulation) for infos about eIDAS.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"**Prerequisite:** You have to be an registered service with the ID Austria system.\n Information about registering can be obtained [from the EGIZ](https://eid.egiz.gv.at/anbindung/registrierung/).\n\n1. Add `ueberauth_id_austria` to your list of dependencies in `mix.exs`:\n\n   ```elixir\n   def deps do\n     [\n       {:ueberauth_id_austria, \"~> 0.1.0\"}\n     ]\n   end\n   ```\n\n2. Add ID Austria to your Überauth configuration:\n\n   ```elixir\n   config :ueberauth, Ueberauth,\n     providers: [\n       eid: {Ueberauth.Strategy.IdAustria, []}\n     ]\n   ```\n\n3. Add the provider configuration:\n\n   ```elixir\n   config :ueberauth, Ueberauth.Strategy.IdAustria.OAuth,\n     client_id: System.get_env(\"EID_CLIENT_ID\"),\n     client_secret: System.get_env(\"EID_CLIENT_SECRET\")\n   ```\n\n4. Setup your auth controller with the Überauth plug:\n\n   ```elixir\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n      plug Ueberauth\n\n      ...\n    end\n   ```\n\n5. Setup the routes:\n\n   ```elixir\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n   ```\n\n6. Your controller needs to implement callbacks to deal with `Ueberauth.Auth`\n   and `Ueberauth.Failure` responses.","ref":"readme.html#installation"},{"type":"extras","title":"Development/Test-System - Overview","doc":"The `Ueberauth.Strategy.IdAustria.OAuth` module differentiates between `:prod`\nand other environments. For `:prod` the productive `eid.oesterreich.gv.at`\nendpoint is used.\n\nOtherwise the test endpoint `eid2.oesterreich.gv.at` is used.\nThere are predefined test identities that can be used via this endpoint. A list\nand description is available at [the EGIZ homepage](https://eid.egiz.gv.at/anbindung/testidentitaeten/vordefinierte-testidentitaeten/).\n\nTo enable testing mode you have to include the following in your configuration:\n\n```elixir\nconfig :ueberauth_id_austria, :prod, false\n```","ref":"readme.html#development-test-system"}],"content_type":"text/markdown"}